unit Simplex;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, StdCtrls, Spin, ExtCtrls;

type
  poleR = array of real;
  poleR2= array of poleR;
 
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button4: TButton;
    Button1: TButton;
    Label1: TLabel;
    pocR: TEdit;
    UpDownR: TUpDown;
    Label2: TLabel;
    PocS: TEdit;
    UpDownS: TUpDown;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Memo1: TMemo;
    StringGrid2: TStringGrid;
    RadioGroup1: TRadioGroup;
    Label3: TLabel;
    StringGrid3: TStringGrid;
    Label4: TLabel;
    Button5: TButton;
    CheckBox1: TCheckBox;
    StringGrid4: TStringGrid;
    Edit1: TEdit;
    Label5: TLabel;
    procedure UpDownRClick(Sender: TObject; Button: TUDBtnType);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDownSClick(Sender: TObject; Button: TUDBtnType);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ChangeMatrix(r, s : byte);
    procedure initialMatrix;
    procedure showSolution;
    procedure ShowTable;
    function optimal : boolean;   // stlpcove pravidlo
    procedure RowRule;
    procedure Transformation;

  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  a : poleR2; // dynamic 2-dimensional array
  b : array of shortInt;  // basis
  m, n : byte;            // m-constraints, n-variables
  r, s : byte;            //index of pivot row and column
  noOpt  : boolean;     // no optimal solution due to the unbounded
  bolOznam : boolean;

implementation

{$R *.dfm}

//*********************************************
procedure TForm1.Button3Click(Sender: TObject);
{simplex method}

begin
  initialMatrix;
  while not optimal do
  begin
    RowRule;
    if not noOpt then transformation else
                                      begin
                                        showSolution;
                                        exit
                                      end;
    showTable;
    ShowMessage('Steps');

  end;
   showSolution;
end;


//**********************************
function tForm1.optimal : boolean;
{ column selection rule
 }

begin



end;

//********************************
procedure tForm1.rowRule;
{row selection rule

 1. pivot row and column in variables r and s
 2. b[r] := s
 3. if you can't find a pivot row, set noOpt:=true}

begin



end;

//*****************************
procedure tForm1.transformation;
{pivotova transformacia podla riadka r a podla stlpca s}


begin

{doplnit kod}

end;


//*****************************************************************
procedure TForm1.UpDownRClick(Sender: TObject; Button: TUDBtnType);
begin
  changeMatrix(upDownR.Position, upDownS.Position);
end;

//*****************************************************************
procedure TForm1.UpDownSClick(Sender: TObject; Button: TUDBtnType);
begin
  changeMatrix(upDownR.Position, upDownS.Position);
end;

//*********************************************
procedure TForm1.Button4Click(Sender: TObject);

var pocRiad, pocStlp : byte;
    i : byte;

begin
  memo1.Clear;
  edit1.Clear;

  pocRiad := upDownR.Max;
  pocStlp := upDownS.Max;

  for i := 1 to pocStlp do stringGrid3.Cols[i].Clear;
  for i := 1 to pocRiad do
  begin
    stringGrid1.Rows[i].Clear;
    stringGrid1.Cells[0,i] := '0';
    stringGrid2.Rows[i].Clear;
    stringGrid4.Rows[i].Clear;
  end;
  changeMatrix(UpDownR.Position,UpDownS.Position);
end;

//*******************************************
procedure TForm1.FormCreate(Sender: TObject);

var i : byte;

begin
  changeMatrix(5,5);
  radioGroup1.ItemIndex := 0;
  edit1.Clear;
  stringGrid3.Cells[0,0] := '1';
  for i := 1 to 19 do stringGrid1.cells[0,i] := '0';
  for i := 0 to 20 do stringGrid1.Cells[i,0] := 'x'+intToStr(i);
end;


//*********************************************
procedure TForm1.Button2Click(Sender: TObject);

var textovySubor : textFile;

begin
//  assign
//  if saveDialog1.Execute then
  begin

  end;
end;


//*********************************************
procedure TForm1.Button1Click(Sender: TObject);

var textSub : textFile;
    i, j   : byte;
    pomStr : string;

begin
  getDir(0,pomStr);
  openDialog1.InitialDir := pomStr;
  if openDialog1.Execute then
  begin
    assignFile(textSub, openDialog1.fileName);
    reset(textSub);
    readln(textSub, pomStr);
    if pomStr = 'max' then radioGroup1.ItemIndex := 1
                              else radioGroup1.ItemIndex := 0;
    readln(textSub, m, n);
    changeMatrix(m, n);
    setLength(b,m+1);
    setLength(a,m+1);
    for i := 0 to m do setLength(a[i],n+2);

    for i := 0 to m do
    begin
      for j := 1 to n do read(textSub, a[i, j]);
      readln(textSub, a[i, n+1]);
    end;
    for i := 1 to m do  read(textSub, b[i]);
  end;
  closeFile(TextSub);
  ShowTable;
end;

//*****************************************
procedure TForm1.changeMatrix(r, s : byte);

var i, j : byte;

begin
  upDownR.Position := r;
  upDownS.Position := s;
  stringGrid2.RowCount := upDownR.Position+1;
  stringGrid3.ColCount := upDownS.Position+1;
  stringGrid4.RowCount := upDownR.Position+1;
  stringGrid2.Cells[0,0] := 'Basis';
  stringGrid4.Cells[0,0] := 'b';

  with stringGrid1 do
  begin
    RowCount := upDownR.Position+1;
    ColCount := upDownS.Position+1;
  end;

end;

//*********************************
procedure Tform1.initialMatrix;

var i, j : byte;

begin
    bolOznam := false;
    m := upDOwnR.Position;
    n := upDownS.Position;
    setLength(b,m+1);
    setLength(a,m+1);  //zaciatok nedimenzovania matice a
    for i := 0 to m do setLength(a[i],n+2); //koniec nedimenzovania matice a

    b[0]  := 0;
    a[0,0]:= 1;
    for i := 1 to m do
    begin
      if stringGrid2.Cells[0,i]<>'' then b[i]:=strToInt(stringGrid2.Cells[0,i])
                                    else
                                    begin
                                      showMessage('Insert indexes to basis!');
                                      bolOznam := true;
                                      exit;
                                    end;
      if stringGrid4.Cells[0, i] = '' then stringGrid4.Cells[0, i] := '0';
      a[i,n+1]:=strToFloat(stringGrid4.cells[0,i]); //prava strana
      for j := 1 to n do
      begin
        if stringGrid1.Cells[j, i] = '' then stringGrid1.Cells[j, i] := '0';
        a[i,j] := strToFloat(stringGrid1.Cells[j, i]);
      end;
    end;

    {spracovanie nulteho riadka: cTb-cj}
    if Edit1.Text = '' then a[0,n+1] := 0
                       else a[0,n+1] :=-1*strToFloat(Edit1.Text);
    for j := 1 to n do
    begin
        if stringGrid3.Cells[j,0] = '' then stringGrid3.Cells[j,0] := '0';
        a[0,j] :=  -1*strToFloat(stringGrid3.Cells[j,0]);
    end;
    for j := 1 to n+1 do
    for i := 1 to m do
        a[0,j] := a[0,j]+a[i,j]*strToFloat(stringGrid3.Cells[b[i],0]);
    if radioGroup1.ItemIndex = 1 then
      for j := 1 to n do a[0,j] := -1*a[0,j];
    ShowTable;
end;


//****************************
procedure tForm1.ShowTable;

var i, j : byte;

begin
  for j := 1 to n do
  begin
    for i := 1 to m do stringGrid1.Cells[j,i] := floatToStr(a[i,j]);
    stringGrid3.Cells[j,0] := floatToStr(a[0,j]);
  end;
  edit1.Text := FloatToStr(a[0,n+1]);
  for i := 1 to m do
    begin
      stringGrid4.Cells[0,i] := floatToStr(a[i, n+1]);
      stringGrid2.Cells[0,i] := floatToStr(b[i]);
    end;
end;


//*****************************
procedure TForm1.ShowSolution;

var i, j : byte;
    riadok : string;
    nekonecneVela : boolean;
begin
  memo1.Clear;
  if noOpt then
  begin
    memo1.Lines.Add('No optimal solution');
    exit;
  end;
  for i := 1 to m do
  begin
    riadok := 'x['+intToStr(b[i])+']='+floatToStr(a[i,n+1]);
    memo1.Lines.Add(riadok);
  end;
end;





end.

